diff --git a/src/main/java/net/minecraft/core/item/tag/ItemTags.java b/src/main/java/net/minecraft/core/item/tag/ItemTags.java
index b52add1d2..559e9155a 100644
--- a/src/main/java/net/minecraft/core/item/tag/ItemTags.java
+++ b/src/main/java/net/minecraft/core/item/tag/ItemTags.java
@@ -13,11 +13,16 @@ public abstract class ItemTags
     /**
      * Items with this tag will not destroy blocks in creative mode
      */
-    public static Tag<Item> preventCreativeMining = Tag.of("prevent_creative_mining");
+    public static Tag<Item> PREVENT_CREATIVE_MINING = Tag.of("prevent_creative_mining");
     /**
      * Items with this tag will break blocks with silk touch
      */
-    public static Tag<Item> isSilkTouch = Tag.of("is_silk_touch");
+    public static Tag<Item> IS_SILK_TOUCH = Tag.of("is_silk_touch");
+    /**
+     * Items with this tag will not be shown in the creative inventory.
+     */
+    public static Tag<Item> NOT_IN_CREATIVE_MENU = Tag.of("not_in_creative_menu");
+
     public static List<Tag<Item>> TAG_LIST;
 
     static
diff --git a/src/main/java/net/minecraft/core/net/ServerAddress.java b/src/main/java/net/minecraft/core/net/ServerAddress.java
new file mode 100644
index 000000000..df4a0c685
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/ServerAddress.java
@@ -0,0 +1,80 @@
+package net.minecraft.core.net;
+
+import javax.naming.directory.Attributes;
+import javax.naming.directory.InitialDirContext;
+import java.util.Hashtable;
+
+public class ServerAddress {
+    private final String ipAddress;
+    private final int serverPort;
+
+    private ServerAddress(String ip, int port) {
+        this.ipAddress = ip;
+        this.serverPort = port;
+    }
+
+    public String getIP() {
+        return this.ipAddress;
+    }
+
+    public int getPort() {
+        return this.serverPort;
+    }
+
+    public static ServerAddress resolveServerIP(String ipToResolve) {
+        if (ipToResolve == null) {
+            return null;
+        } else {
+            String[] ipSplit = ipToResolve.split(":");
+            if (ipToResolve.startsWith("[")) {
+                int ipv6End = ipToResolve.indexOf("]");
+                if (ipv6End > 0) {
+                    String ipv6IP = ipToResolve.substring(1, ipv6End);
+                    String port = ipToResolve.substring(ipv6End + 1).trim();
+                    if (port.startsWith(":") && !port.isEmpty()) {
+                        port = port.substring(1);
+                        ipSplit = new String[]{ipv6IP, port};
+                    } else {
+                        ipSplit = new String[]{ipv6IP};
+                    }
+                }
+            }
+
+            if (ipSplit.length > 2) {
+                ipSplit = new String[]{ipToResolve};
+            }
+
+            String ip = ipSplit[0];
+            int port = ipSplit.length > 1 ? parseIntWithDefault(ipSplit[1], 25565) : 25565;
+            if (port == 25565) {
+                String[] recordSplit = resolveSRVRecord(ip);
+                ip = recordSplit[0];
+                port = parseIntWithDefault(recordSplit[1], 25565);
+            }
+
+            return new ServerAddress(ip, port);
+        }
+    }
+
+    private static String[] resolveSRVRecord(String ip) {
+        try {
+            Hashtable<String, String> contextTable = new Hashtable<>();
+            contextTable.put("java.naming.factory.initial", "com.sun.jndi.dns.DnsContextFactory");
+            contextTable.put("java.naming.provider.url", "dns:");
+            InitialDirContext context = new InitialDirContext(contextTable);
+            Attributes attr = context.getAttributes("_minecraft._tcp." + ip, new String[]{"SRV"});
+            String[] ipSplit = attr.get("srv").get().toString().split(" ", 4);
+            return new String[]{ipSplit[3], ipSplit[2]};
+        } catch (Throwable t) {
+            return new String[]{ip, Integer.toString(25565)};
+        }
+    }
+
+    private static int parseIntWithDefault(String str, int defaultVal) {
+        try {
+            return Integer.parseInt(str.trim());
+        } catch (Exception e) {
+            return defaultVal;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/ServerData.java b/src/main/java/net/minecraft/core/net/ServerData.java
index 68b8dc554..308fcc8de 100644
--- a/src/main/java/net/minecraft/core/net/ServerData.java
+++ b/src/main/java/net/minecraft/core/net/ServerData.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.net;
 
 import com.mojang.nbt.CompoundTag;
+import org.apache.logging.log4j.core.jmx.Server;
 
 import java.time.LocalDateTime;
 import java.time.ZoneOffset;
@@ -40,19 +41,7 @@ public class ServerData
         tag.putCompound(Integer.toString(index), subTag);
     }
 
-    public String getHostName()
-    {
-        String[] split = address.split(":");
-        return split[0];
-    }
-
-    public int getPort()
-    {
-        String[] split = address.split(":");
-        try {
-            return Integer.parseInt(split[split.length - 1]);
-        } catch (NumberFormatException e) {
-            return 25565;
-        }
+    public ServerAddress getServerAddress() {
+        return ServerAddress.resolveServerIP(address);
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java b/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
index ed9b6ea0d..95214f844 100644
--- a/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
@@ -18,7 +18,7 @@ public class ClientPlayerCommandSender extends PlayerCommandSender{
 
 	@Override
 	public boolean isAdmin() {
-		return true;
+		return minecraft.theWorld.getLevelData().getCheatsEnabled();
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/core/player/inventory/ContainerGuidebook.java b/src/main/java/net/minecraft/core/player/inventory/ContainerGuidebook.java
index 4b0a5dda3..cb16461da 100644
--- a/src/main/java/net/minecraft/core/player/inventory/ContainerGuidebook.java
+++ b/src/main/java/net/minecraft/core/player/inventory/ContainerGuidebook.java
@@ -25,42 +25,6 @@ public class ContainerGuidebook extends Container
 		return null;
 	}
 
-	public void setRecipes(final EntityPlayer player, final ContainerGuidebookRecipeBase[] recipes, StatsCounter statWriter)
-	{
-		inventorySlots.clear();
-
-		for (int i = 0; i < recipes.length; i++)
-		{
-			final int xOffset = (158 * (i / 3)) - 41;
-			final int yOffset = (62 * (i % 3)) + 3;
-			if (recipes[i] == null)
-			{
-				continue;
-			}
-
-			for (int j = 0; j < recipes[i].inventorySlots.size(); j++)
-			{
-				final SlotGuidebook slot = (SlotGuidebook) recipes[i].inventorySlots.get(j);
-
-				boolean discovered;
-
-				if (slot.item == null)
-				{
-					discovered = false;
-				}
-				else
-				{
-
-					discovered = statWriter.readStat(StatList.pickUpItemStats[slot.item.itemID]) > 0;
-				}
-				if(player.getGamemode() == Gamemode.creative)
-					discovered = true;
-
-				//addSlot(new SlotGuidebook(inventorySlots.size(), slot.xDisplayPosition + xOffset, slot.yDisplayPosition + yOffset, slot.item, discovered));
-			}
-		}
-	}
-	
 	@Override
 	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
 		return null;
diff --git a/src/main/java/net/minecraft/core/player/inventory/ContainerPlayerCreative.java b/src/main/java/net/minecraft/core/player/inventory/ContainerPlayerCreative.java
index e3a1f5be6..e503187de 100644
--- a/src/main/java/net/minecraft/core/player/inventory/ContainerPlayerCreative.java
+++ b/src/main/java/net/minecraft/core/player/inventory/ContainerPlayerCreative.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.player.inventory;
 
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -141,7 +142,9 @@ public class ContainerPlayerCreative extends ContainerPlayer
 						count++;
 					}
 				}
-				else if (id == Block.chestPlanksOakPainted.id || id == Block.slabPlanksOakPainted.id || id == Block.fencegatePlanksOakPainted.id || id == Block.stairsPlanksOakPainted.id)
+				else if (id == Block.chestPlanksOakPainted.id || id == Block.slabPlanksOakPainted.id || id == Block.fencegatePlanksOakPainted.id
+					  || id == Block.stairsPlanksOakPainted.id || id == Block.doorPlanksOakPaintedBottom.id || id == Block.doorPlanksOakPaintedTop.id
+					  || id == Block.trapdoorPlanksOakPainted.id)
 				{
 					for (int i = 0x10; i < 0x100; i += 0x10)
 					{
@@ -154,7 +157,7 @@ public class ContainerPlayerCreative extends ContainerPlayer
 		
 		for (int i = Block.blocksList.length; i < Item.itemsList.length; i++)
 		{
-			if (Item.itemsList[i] != null && !Item.itemsList[i].notInCreativeMenu)
+			if (Item.itemsList[i] != null && !Item.itemsList[i].hasTag(ItemTags.NOT_IN_CREATIVE_MENU))
 			{
 				creativeItems.add(new ItemStack(Item.itemsList[i]));
 				count++;
@@ -168,7 +171,7 @@ public class ContainerPlayerCreative extends ContainerPlayer
 					}
 				}
 
-				if (i == Item.dye.id)
+				if (i == Item.dye.id || i == Item.doorOakPainted.id)
 				{
 					for (int j = 1; j < 16; j++)
 					{
diff --git a/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java b/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java
index fb88ea2d7..4e4b50b8b 100644
--- a/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java
+++ b/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java
@@ -17,7 +17,9 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemArmor;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.DamageType;
+import org.jetbrains.annotations.Nullable;
 
 public class InventoryPlayer
     implements IInventory
@@ -32,6 +34,7 @@ public class InventoryPlayer
         this.player = player;
     }
 
+    @Nullable
     public ItemStack getCurrentItem()
     {
         if(currentItem < 9 + hotbarOffset && currentItem >= hotbarOffset)
@@ -136,7 +139,7 @@ public class InventoryPlayer
     	}
     	else
     	{
-    		if (Item.itemsList[itemstack.itemID].notInCreativeMenu) return currentItem;
+    		if (Item.itemsList[itemstack.itemID].hasTag(ItemTags.NOT_IN_CREATIVE_MENU)) return currentItem;
     	}
     	
     	for (int j = hotbarOffset; j < 9 + hotbarOffset; j++)
diff --git a/src/main/java/net/minecraft/core/player/inventory/creative/CreativeTab.java b/src/main/java/net/minecraft/core/player/inventory/creative/CreativeTab.java
new file mode 100644
index 000000000..60ad57121
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/creative/CreativeTab.java
@@ -0,0 +1,27 @@
+package net.minecraft.core.player.inventory.creative;
+
+import net.minecraft.core.item.ItemStack;
+
+public class CreativeTab {
+    private final String translationKey;
+    private final ItemStack icon;
+    private final CreativeTabItemProvider itemProvider;
+
+    public CreativeTab(String translationKey, ItemStack icon, CreativeTabItemProvider itemProvider) {
+        this.translationKey = translationKey;
+        this.icon = icon;
+        this.itemProvider = itemProvider;
+    }
+
+    public String getTranslationKey() {
+        return translationKey;
+    }
+
+    public ItemStack getIcon() {
+        return icon;
+    }
+
+    public CreativeTabItemProvider getItemProvider() {
+        return itemProvider;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/creative/CreativeTabItemProvider.java b/src/main/java/net/minecraft/core/player/inventory/creative/CreativeTabItemProvider.java
new file mode 100644
index 000000000..f31a41f8d
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/creative/CreativeTabItemProvider.java
@@ -0,0 +1,9 @@
+package net.minecraft.core.player.inventory.creative;
+
+import net.minecraft.core.item.ItemStack;
+
+import java.util.List;
+
+public interface CreativeTabItemProvider {
+    List<ItemStack> getItems();
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/creative/CreativeTabs.java b/src/main/java/net/minecraft/core/player/inventory/creative/CreativeTabs.java
new file mode 100644
index 000000000..8a60d940e
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/creative/CreativeTabs.java
@@ -0,0 +1,73 @@
+package net.minecraft.core.player.inventory.creative;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.tag.ItemTags;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.List;
+
+public abstract class CreativeTabs {
+    private static boolean initialized = false;
+    private static final List<CreativeTab> tabList = new ArrayList<>();
+
+    public static CreativeTab ALL;
+    public static CreativeTab BLOCKS;
+    public static CreativeTab ITEMS;
+
+    public static void init() {
+        if (initialized) return;
+        initialized = true;
+
+        ALL = register("tab.creative.all", new ItemStack(Item.ammoSnowball), () -> {
+            List<ItemStack> items = new ArrayList<>();
+            for (int i = 0; i < Item.highestItemId; i++) {
+                Item item = Item.itemsList[i];
+                if (item != null && !item.hasTag(ItemTags.NOT_IN_CREATIVE_MENU)) {
+                    items.add(new ItemStack(item));
+                }
+            }
+            for (int i = 0; i < Block.highestBlockId; i++) {
+                Block block = Block.blocksList[i];
+                if (block != null && !block.hasTag(BlockTags.NOT_IN_CREATIVE_MENU)) {
+                    items.add(new ItemStack(block));
+                }
+            }
+            return items;
+        });
+        BLOCKS = register("tab.creative.blocks", new ItemStack(Block.grass), () -> {
+            List<ItemStack> items = new ArrayList<>();
+            for (int i = 0; i < Block.highestBlockId; i++) {
+                Block block = Block.blocksList[i];
+                if (block != null && !block.hasTag(BlockTags.NOT_IN_CREATIVE_MENU)) {
+                    items.add(new ItemStack(block));
+                }
+            }
+            return items;
+        });
+        ITEMS = register("tab.creative.items", new ItemStack(Item.string), () -> {
+            List<ItemStack> items = new ArrayList<>();
+            for (int i = 0; i < Item.highestItemId; i++) {
+                Item item = Item.itemsList[i];
+                if (item != null && !item.hasTag(ItemTags.NOT_IN_CREATIVE_MENU)) {
+                    items.add(new ItemStack(item));
+                }
+            }
+            return items;
+        });
+    }
+
+    public static CreativeTab register(String translationKey, ItemStack icon, CreativeTabItemProvider itemProvider) {
+        CreativeTab tab = new CreativeTab(translationKey, icon, itemProvider);
+        tabList.add(tab);
+        return tab;
+    }
+
+    public static List<CreativeTab> getTabList() {
+        return Collections.unmodifiableList(tabList);
+    }
+
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/SlotGuidebook.java b/src/main/java/net/minecraft/core/player/inventory/slot/SlotGuidebook.java
index 6f02a6043..5f80f95ac 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/SlotGuidebook.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/SlotGuidebook.java
@@ -1,13 +1,12 @@
 package net.minecraft.core.player.inventory.slot;
 
 import net.minecraft.client.entity.player.EntityPlayerSP;
-import net.minecraft.core.Global;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.gamemode.Gamemode;
